"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.initialize=exports.isInitialized=exports.enable=exports.isRemoteModuleEnabled=void 0;let events_1=require("events"),objects_registry_1=__importDefault(require("./objects-registry")),type_utils_1=require("../common/type-utils"),electron_1=require("electron"),get_electron_binding_1=require("../common/get-electron-binding"),{Promise:e}=global,v8Util=get_electron_binding_1.getElectronBinding("v8_util"),hasWebPrefsRemoteModuleAPI=(()=>{var e,t;let r=Number(null===(t=null===(e=process.versions.electron)||void 0===e?void 0:e.split("."))||void 0===t?void 0:t[0]);return Number.isNaN(r)||r<14})(),FUNCTION_PROPERTIES=["length","name","arguments","caller","prototype"],rendererFunctionCache=new Map,finalizationRegistry=new FinalizationRegistry(e=>{let t=e.id[0]+"~"+e.id[1],r=rendererFunctionCache.get(t);if(void 0!==r&&void 0===r.deref()&&(rendererFunctionCache.delete(t),!e.webContents.isDestroyed()))try{e.webContents.sendToFrame(e.frameId,"REMOTE_RENDERER_RELEASE_CALLBACK",e.id[0],e.id[1])}catch(e){console.warn(`sendToFrame() failed: ${e}`)}});function getCachedRendererFunction(e){let t=e[0]+"~"+e[1],r=rendererFunctionCache.get(t);if(void 0!==r){let e=r.deref();if(void 0!==e)return e}}function setCachedRendererFunction(e,t,r,n){let o=new WeakRef(n),a=e[0]+"~"+e[1];return rendererFunctionCache.set(a,o),finalizationRegistry.register(n,{id:e,webContents:t,frameId:r}),n}let locationInfo=new WeakMap,getObjectMembers=function(e){let t=Object.getOwnPropertyNames(e);return"function"==typeof e&&(t=t.filter(e=>!FUNCTION_PROPERTIES.includes(e))),t.map(t=>{let r;let n=Object.getOwnPropertyDescriptor(e,t),o=!1;return void 0===n.get&&"function"==typeof e[t]?r="method":((n.set||n.writable)&&(o=!0),r="get"),{name:t,enumerable:n.enumerable,writable:o,type:r}})},getObjectPrototype=function(e){let t=Object.getPrototypeOf(e);return null===t||t===Object.prototype?null:{members:getObjectMembers(t),proto:getObjectPrototype(t)}},valueToMeta=function(e,t,r,n=!1){let o;switch(typeof r){case"object":o=r instanceof Buffer?"buffer":r&&r.constructor&&"NativeImage"===r.constructor.name?"nativeimage":Array.isArray(r)?"array":r instanceof Error?"error":type_utils_1.isSerializableObject(r)?"value":type_utils_1.isPromise(r)?"promise":Object.prototype.hasOwnProperty.call(r,"callee")&&null!=r.length?"array":n&&v8Util.getHiddenValue(r,"simple")?"value":"object";break;case"function":o="function";break;default:o="value"}if("array"===o)return{type:o,members:r.map(r=>valueToMeta(e,t,r,n))};if("nativeimage"===o)return{type:o,value:type_utils_1.serialize(r)};if("object"===o||"function"===o)return{type:o,name:r.constructor?r.constructor.name:"",id:objects_registry_1.default.add(e,t,r),members:getObjectMembers(r),proto:getObjectPrototype(r)};if("buffer"===o)return{type:o,value:r};if("promise"===o)return r.then(function(){},function(){}),{type:o,then:valueToMeta(e,t,function(e,t){r.then(e,t)})};else if("error"===o)return{type:o,value:r,members:Object.keys(r).map(n=>({name:n,value:valueToMeta(e,t,r[n])}))};else return{type:"value",value:r}},throwRPCError=function(e){let t=Error(e);throw t.code="EBADRPC",t.errno=-72,t},removeRemoteListenersAndLogWarning=(e,t)=>{let r=locationInfo.get(t),n=`Attempting to call a function in a renderer window that has been closed or released.
Function provided here: ${r}`;if(e instanceof events_1.EventEmitter){let r=e.eventNames().filter(r=>e.listeners(r).includes(t));r.length>0&&(n+=`
Remote event names: ${r.join(", ")}`,r.forEach(r=>{e.removeListener(r,t)}))}console.warn(n)},fakeConstructor=(e,t)=>new Proxy(Object,{get:(e,r,n)=>"name"===r?t:Reflect.get(e,r,n)}),unwrapArgs=function(t,r,n,o){let a=function(o){switch(o.type){case"nativeimage":return type_utils_1.deserialize(o.value);case"value":return o.value;case"remote-object":return objects_registry_1.default.get(o.id);case"array":return unwrapArgs(t,r,n,o.value);case"buffer":return Buffer.from(o.value.buffer,o.value.byteOffset,o.value.byteLength);case"promise":return e.resolve({then:a(o.then)});case"object":{let e="Object"!==o.name?Object.create({constructor:fakeConstructor(Object,o.name)}):{};for(let{name:t,value:r}of o.members)e[t]=a(r);return e}case"function-with-return-value":{let e=a(o.value);return function(){return e}}case"function":{let e=[n,o.id],a=getCachedRendererFunction(e);if(void 0!==a)return a;let i=function(...e){let a=!1;if(!t.isDestroyed())try{a=!1!==t.sendToFrame(r,"REMOTE_RENDERER_CALLBACK",n,o.id,valueToMeta(t,n,e))}catch(e){console.warn(`sendToFrame() failed: ${e}`)}a||removeRemoteListenersAndLogWarning(this,i)};return locationInfo.set(i,o.location),Object.defineProperty(i,"length",{value:o.length}),setCachedRendererFunction(e,t,r,i),i}default:throw TypeError(`Unknown type: ${o.type}`)}};return o.map(a)},isRemoteModuleEnabledImpl=function(e){let t=e.getLastWebPreferences()||{};return null!=t.enableRemoteModule&&!!t.enableRemoteModule},isRemoteModuleEnabledCache=new WeakMap,isRemoteModuleEnabled=function(e){return hasWebPrefsRemoteModuleAPI&&!isRemoteModuleEnabledCache.has(e)&&isRemoteModuleEnabledCache.set(e,isRemoteModuleEnabledImpl(e)),isRemoteModuleEnabledCache.get(e)};function enable(e){isRemoteModuleEnabledCache.set(e,!0)}exports.isRemoteModuleEnabled=isRemoteModuleEnabled,exports.enable=enable;let handleRemoteCommand=function(e,t){electron_1.ipcMain.on(e,(e,r,...n)=>{let o;if(!exports.isRemoteModuleEnabled(e.sender)){e.returnValue={type:"exception",value:valueToMeta(e.sender,r,Error('@electron/remote is disabled for this WebContents. Call require("@electron/remote/main").enable(webContents) to enable it.'))};return}try{o=t(e,r,...n)}catch(t){o={type:"exception",value:valueToMeta(e.sender,r,t)}}void 0!==o&&(e.returnValue=o)})},emitCustomEvent=function(e,t,...r){let n={sender:e,returnValue:void 0,defaultPrevented:!1};return electron_1.app.emit(t,n,e,...r),e.emit(t,n,...r),n},logStack=function(e,t,r){r&&console.warn(`WebContents (${e.id}): ${t}`,r)},initialized=!1;function isInitialized(){return initialized}function initialize(){if(initialized)throw Error("@electron/remote has already been initialized");initialized=!0,handleRemoteCommand("REMOTE_BROWSER_WRONG_CONTEXT_ERROR",function(e,t,r,n){let o=getCachedRendererFunction([r,n]);void 0!==o&&removeRemoteListenersAndLogWarning(e.sender,o)}),handleRemoteCommand("REMOTE_BROWSER_REQUIRE",function(e,t,r,n){logStack(e.sender,`remote.require('${r}')`,n);let o=emitCustomEvent(e.sender,"remote-require",r);if(void 0===o.returnValue){if(o.defaultPrevented)throw Error(`Blocked remote.require('${r}')`);if(process.mainModule)o.returnValue=process.mainModule.require(r);else{let e=module;for(;e.parent;)e=e.parent;o.returnValue=e.require(r)}}return valueToMeta(e.sender,t,o.returnValue)}),handleRemoteCommand("REMOTE_BROWSER_GET_BUILTIN",function(e,t,r,n){logStack(e.sender,`remote.getBuiltin('${r}')`,n);let o=emitCustomEvent(e.sender,"remote-get-builtin",r);if(void 0===o.returnValue){if(o.defaultPrevented)throw Error(`Blocked remote.getBuiltin('${r}')`);o.returnValue=require("electron")[r]}return valueToMeta(e.sender,t,o.returnValue)}),handleRemoteCommand("REMOTE_BROWSER_GET_GLOBAL",function(e,t,r,n){logStack(e.sender,`remote.getGlobal('${r}')`,n);let o=emitCustomEvent(e.sender,"remote-get-global",r);if(void 0===o.returnValue){if(o.defaultPrevented)throw Error(`Blocked remote.getGlobal('${r}')`);o.returnValue=global[r]}return valueToMeta(e.sender,t,o.returnValue)}),handleRemoteCommand("REMOTE_BROWSER_GET_CURRENT_WINDOW",function(e,t,r){logStack(e.sender,"remote.getCurrentWindow()",r);let n=emitCustomEvent(e.sender,"remote-get-current-window");if(void 0===n.returnValue){if(n.defaultPrevented)throw Error("Blocked remote.getCurrentWindow()");n.returnValue=e.sender.getOwnerBrowserWindow()}return valueToMeta(e.sender,t,n.returnValue)}),handleRemoteCommand("REMOTE_BROWSER_GET_CURRENT_WEB_CONTENTS",function(e,t,r){logStack(e.sender,"remote.getCurrentWebContents()",r);let n=emitCustomEvent(e.sender,"remote-get-current-web-contents");if(void 0===n.returnValue){if(n.defaultPrevented)throw Error("Blocked remote.getCurrentWebContents()");n.returnValue=e.sender}return valueToMeta(e.sender,t,n.returnValue)}),handleRemoteCommand("REMOTE_BROWSER_CONSTRUCTOR",function(e,t,r,n){n=unwrapArgs(e.sender,e.frameId,t,n);let o=objects_registry_1.default.get(r);return null==o&&throwRPCError(`Cannot call constructor on missing remote object ${r}`),valueToMeta(e.sender,t,new o(...n))}),handleRemoteCommand("REMOTE_BROWSER_FUNCTION_CALL",function(e,t,r,n){n=unwrapArgs(e.sender,e.frameId,t,n);let o=objects_registry_1.default.get(r);null==o&&throwRPCError(`Cannot call function on missing remote object ${r}`);try{return valueToMeta(e.sender,t,o(...n),!0)}catch(t){let e=Error(`Could not call remote function '${o.name||"anonymous"}'. Check that the function signature is correct. Underlying error: ${t}
`+(t instanceof Error?`Underlying stack: ${t.stack}
`:""));throw e.cause=t,e}}),handleRemoteCommand("REMOTE_BROWSER_MEMBER_CONSTRUCTOR",function(e,t,r,n,o){o=unwrapArgs(e.sender,e.frameId,t,o);let a=objects_registry_1.default.get(r);return null==a&&throwRPCError(`Cannot call constructor '${n}' on missing remote object ${r}`),valueToMeta(e.sender,t,new a[n](...o))}),handleRemoteCommand("REMOTE_BROWSER_MEMBER_CALL",function(e,t,r,n,o){o=unwrapArgs(e.sender,e.frameId,t,o);let a=objects_registry_1.default.get(r);null==a&&throwRPCError(`Cannot call method '${n}' on missing remote object ${r}`);try{return valueToMeta(e.sender,t,a[n](...o),!0)}catch(t){let e=Error(`Could not call remote method '${n}'. Check that the method signature is correct. Underlying error: ${t}`+(t instanceof Error?`Underlying stack: ${t.stack}
`:""));throw e.cause=t,e}}),handleRemoteCommand("REMOTE_BROWSER_MEMBER_SET",function(e,t,r,n,o){o=unwrapArgs(e.sender,e.frameId,t,o);let a=objects_registry_1.default.get(r);return null==a&&throwRPCError(`Cannot set property '${n}' on missing remote object ${r}`),a[n]=o[0],null}),handleRemoteCommand("REMOTE_BROWSER_MEMBER_GET",function(e,t,r,n){let o=objects_registry_1.default.get(r);return null==o&&throwRPCError(`Cannot get property '${n}' on missing remote object ${r}`),valueToMeta(e.sender,t,o[n])}),handleRemoteCommand("REMOTE_BROWSER_DEREFERENCE",function(e,t,r){objects_registry_1.default.remove(e.sender,t,r)}),handleRemoteCommand("REMOTE_BROWSER_CONTEXT_RELEASE",(e,t)=>(objects_registry_1.default.clear(e.sender,t),null))}exports.isInitialized=isInitialized,exports.initialize=initialize;